
/* error.c - print help and error messages to stderr */

#include "main.h"

/* print help option to stderr */

void	opt_printf (char *msg)
{
	fprintf (stderr, "         %s\n", msg);
}

/* print program usage */

void	print_usage (void)
{
	fprintf (stderr, "tempomod v1.0.0");
	fprintf (stderr, " - written by Istvan Varga, Jul 2001\n\n");
	fprintf (stderr, "usage: %s [options...]\n\n", argv[0]);
	fprintf (stderr, "options:\n");
	opt_printf ("-h, -help");
	opt_printf ("    Print this message.");
	opt_printf ("-avg_tempo <average tempo> (default: 120.0)");
	opt_printf ("-start_beat <time offset in beats> (default: 0.0)");
	opt_printf ("-nbeats <number of beats, integer> (default: 64)");
	opt_printf ("    Warning: this option clears tempo data.");
	opt_printf ("-b_res <time resolution in log2 of beats> (default: -2)");
	opt_printf ("    Warning: this option clears tempo data.");
	opt_printf ("-sine <depth (-1 - +1)> <loop time (in beats)>");
	opt_printf ("      <start phase (0 - 1)> <end phase>");
	opt_printf ("    Modulate tempo by a sine wave.");
	opt_printf ("-trsw <depth (-1 - +1)> <loop time (in beats)>");
	opt_printf ("      <attack time / loop time (0 - 1)> <phase (0 - 1)>");
	opt_printf ("    Modulate tempo by a triangle (attack = 0.5) or saw");
	opt_printf ("    (attack = 0.0 or 1.0) wave.");
	fprintf (stderr, "\n");
}

/* print error message */

void	err_msg (char *msg, int err_arg)
{
	if (msg != NULL) {
		fprintf (stderr, "*** %s", argv[0]);
		fprintf (stderr, ": %s", msg);
		if (err_arg > 0) fprintf (stderr, ": %s", argv[err_arg]);
		fprintf (stderr, "\n");
	}
	exit (-1);
}

/* print usage and error message */

void	err_usage (char *msg, int err_arg)
{
	print_usage ();
	err_msg (msg, err_arg);
}

