
/* tempomod - utility to modulate tempo of Csound scores	*/
/* written by Istvan Varga, Jul 2001				*/

#include "main.h"

double	tempo[MAX_PTS][2];	/* tempo array				*/
double	t_lst[MAX_LST][2];	/* list of tempo values to be printed	*/
double	beat_time;		/* length (in beats) of tempo segments	*/
double	start_beat;		/* beat offset				*/
double	avg_tempo;		/* average tempo			*/
char	**argv;			/* command line arguments		*/
int	nr_pts;			/* number of tempo segments		*/
int	nr_args;		/* number of arguments remaining	*/
int	argptr;			/* current argument			*/
int	b_res;			/* time resolution in log2 of beats	*/
int	nbeats;			/* number of beats			*/

int	main (int argc, char **argv_main)
{
	/* set default parameters */

	start_beat = 0.0;
	avg_tempo = 120.0;
	nbeats = 64;
	b_res = -2;
	update_nr_pts ();

	/* initialize tempo array */

	clear_tempo ();

	/* parse command line options */

	argv = argv_main;
	nr_args = argc - 1; argptr = 1; while (nr_args > 0) {
		if (!(strcmp (argv[argptr], "-h"))) {
			opt_help ();
		} else if (!(strcmp (argv[argptr], "-help"))) {
			opt_help ();
		} else if (!(strcmp (argv[argptr], "-avg_tempo"))) {
			opt_avg_tempo ();
		} else if (!(strcmp (argv[argptr], "-start_beat"))) {
			opt_start_beat ();
		} else if (!(strcmp (argv[argptr], "-nbeats"))) {
			opt_nbeats ();
		} else if (!(strcmp (argv[argptr], "-b_res"))) {
			opt_b_res ();
		} else if (!(strcmp (argv[argptr], "-sine"))) {
			opt_sine ();
		} else if (!(strcmp (argv[argptr], "-trsw"))) {
			opt_trsw ();
		} else {
			err_usage ("invalid option", argptr);
		}
	}

	/* print tempo values */

	if (nr_pts > MAX_PTS) err_msg ("error: too many tempo segments", -1);
	if (nr_pts > 0) normalize_tempo ();
	print_tempo ();

	return 0;
}

